import 'package:bolter_flutter/bolter_flutter.dart';
import 'package:flutter/cupertino.dart';
import 'package:flutter/material.dart';

class MyPresenter extends Presenter<MyPresenter> {

  late final b = BolterProvider.of(context);

  void initState(){
    b.hashCode;
  }

  var _value = 0;

  void increment() {
    runAndUpdate(action: () {
      _value++;
    });
  }

  ValueStream<int> get valueStream => stream(() => _value);
}

void main() async {
  runApp(
    BolterProvider(
      container: DependenciesContainer(),
      child: PresenterProvider(
        presenter: MyPresenter(),
        child: Builder(
          builder: (ctx) {
            return MaterialApp(
              home: Scaffold(
                body: Center(
                  child: Column(
                    children: [
                      ValueStreamBuilder(
                        stream: ctx.presenter<MyPresenter>().valueStream,
                        builder: (BuildContext context, int value) {
                          return Text(value.toString());
                        },
                      ),
                      Padding(
                        padding: EdgeInsets.only(top: 16),
                        child: ElevatedButton(
                          child: Text("Increment"),
                          onPressed: () {
                            ctx.presenter<MyPresenter>().increment();
                          },
                        ),
                      )
                    ],
                  ),
                ),
              ),
            );
          },
        ),
      ),
    ),
  );
}
