import 'dart:async';
import 'package:bolter/bolter.dart';
import 'package:bolter_flutter/bolter_flutter.dart';
import 'package:dependencies_container/dependencies_container.dart';
import 'package:flutter/foundation.dart';
import 'package:flutter/material.dart';
import 'package:provider/provider.dart';
import 'package:provider/single_child_widget.dart';

part 'presenter/presenter.dart';

part 'presenter/presenter_provider.dart';

// navigator = navigator ?? context.findAncestorStateOfType<NavigatorState>();

class BolterProvider extends StatefulWidget {
  final DependenciesContainer _container;
  final Widget child;

  const BolterProvider({
    required DependenciesContainer container,
    Key? key,
    required this.child,
  })  : _container = container,
        super(key: key);


  static BolterProviderState of(BuildContext context) =>
      context.findAncestorStateOfType<BolterProviderState>()!;

  @override
  State<BolterProvider> createState() => BolterProviderState();
}

class BolterProviderState extends State<BolterProvider> {
  static final _bolter = Bolter();

  T dependency<T>({bool existingInstance = false}) =>
      widget._container.dependency<T>(existingInstance: existingInstance);

  DependenciesContainer get dependenciesContainer => widget._container;

  @override
  Widget build(BuildContext context) {
    return widget.child;
  }
}

extension BolterProviderExtension on BuildContext {
  BolterProviderState bolterProvider() => BolterProvider.of(this);
}
